-------------------------------------------------------------------------------
-- system_stub.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

entity system_stub is
  port (
    fpga_0_USB_UART_RX_pin : in std_logic;
    fpga_0_USB_UART_TX_pin : out std_logic;
    fpga_0_LEDS_4BIT_GPIO_IO_pin : inout std_logic_vector(0 to 3);
    fpga_0_CS_PUSH_3BIT_GPIO_in_pin : in std_logic_vector(0 to 2);
    fpga_0_TEMP_SENSOR_Scl_pin : inout std_logic;
    fpga_0_TEMP_SENSOR_Sda_pin : inout std_logic;
    fpga_0_FLASH_2Mx16_Mem_DQ_pin : inout std_logic_vector(0 to 15);
    fpga_0_FLASH_2Mx16_Mem_A_pin : out std_logic_vector(10 to 30);
    fpga_0_FLASH_2Mx16_Mem_WEN_pin : out std_logic;
    fpga_0_FLASH_2Mx16_Mem_OEN_pin : out std_logic_vector(0 to 0);
    fpga_0_FLASH_2Mx16_Mem_CEN_pin : out std_logic_vector(0 to 0);
    fpga_0_FLASH_2Mx16_Mem_RPN_pin : out std_logic;
    fpga_0_FLASH_2Mx16_BYTEn_pin : out std_logic;
    sys_clk_pin : in std_logic;
    sys_rst_pin : in std_logic
  );
end system_stub;

architecture STRUCTURE of system_stub is

  component system is
    port (
      fpga_0_USB_UART_RX_pin : in std_logic;
      fpga_0_USB_UART_TX_pin : out std_logic;
      fpga_0_LEDS_4BIT_GPIO_IO_pin : inout std_logic_vector(0 to 3);
      fpga_0_CS_PUSH_3BIT_GPIO_in_pin : in std_logic_vector(0 to 2);
      fpga_0_TEMP_SENSOR_Scl_pin : inout std_logic;
      fpga_0_TEMP_SENSOR_Sda_pin : inout std_logic;
      fpga_0_FLASH_2Mx16_Mem_DQ_pin : inout std_logic_vector(0 to 15);
      fpga_0_FLASH_2Mx16_Mem_A_pin : out std_logic_vector(10 to 30);
      fpga_0_FLASH_2Mx16_Mem_WEN_pin : out std_logic;
      fpga_0_FLASH_2Mx16_Mem_OEN_pin : out std_logic_vector(0 to 0);
      fpga_0_FLASH_2Mx16_Mem_CEN_pin : out std_logic_vector(0 to 0);
      fpga_0_FLASH_2Mx16_Mem_RPN_pin : out std_logic;
      fpga_0_FLASH_2Mx16_BYTEn_pin : out std_logic;
      sys_clk_pin : in std_logic;
      sys_rst_pin : in std_logic
    );
  end component;

begin

  system_i : system
    port map (
      fpga_0_USB_UART_RX_pin => fpga_0_USB_UART_RX_pin,
      fpga_0_USB_UART_TX_pin => fpga_0_USB_UART_TX_pin,
      fpga_0_LEDS_4BIT_GPIO_IO_pin => fpga_0_LEDS_4BIT_GPIO_IO_pin,
      fpga_0_CS_PUSH_3BIT_GPIO_in_pin => fpga_0_CS_PUSH_3BIT_GPIO_in_pin,
      fpga_0_TEMP_SENSOR_Scl_pin => fpga_0_TEMP_SENSOR_Scl_pin,
      fpga_0_TEMP_SENSOR_Sda_pin => fpga_0_TEMP_SENSOR_Sda_pin,
      fpga_0_FLASH_2Mx16_Mem_DQ_pin => fpga_0_FLASH_2Mx16_Mem_DQ_pin,
      fpga_0_FLASH_2Mx16_Mem_A_pin => fpga_0_FLASH_2Mx16_Mem_A_pin,
      fpga_0_FLASH_2Mx16_Mem_WEN_pin => fpga_0_FLASH_2Mx16_Mem_WEN_pin,
      fpga_0_FLASH_2Mx16_Mem_OEN_pin => fpga_0_FLASH_2Mx16_Mem_OEN_pin(0 to 0),
      fpga_0_FLASH_2Mx16_Mem_CEN_pin => fpga_0_FLASH_2Mx16_Mem_CEN_pin(0 to 0),
      fpga_0_FLASH_2Mx16_Mem_RPN_pin => fpga_0_FLASH_2Mx16_Mem_RPN_pin,
      fpga_0_FLASH_2Mx16_BYTEn_pin => fpga_0_FLASH_2Mx16_BYTEn_pin,
      sys_clk_pin => sys_clk_pin,
      sys_rst_pin => sys_rst_pin
    );

end architecture STRUCTURE;

