set bitfile=../implementation/download.bit
set outfile=periph_test_xipFlash

echo off

REM ##########################################################################
REM # This will create the iMPACT CMD file and then generate the BPI-up      #
REM #    binary file for the given bitfile                                   #
REM #    Bryan Fletcher, Avnet                                               #
REM #                                                                        #
REM # - Tested on the Avnet Spartan-3A Evaluation Board                      #
REM #   AvProg v3.3.7 used for erasing and programming the flash             #
REM #   09 Jul 2008                                                          #
REM ##########################################################################

REM # Convert to MCS as this is the format required by XMCSUTIL for bit manipulation
REM # This operation does the bit-reversal within bytes
@echo setMode -pff                                                 >  impact_batch_commands.cmd 
@echo setSubmode -pffparallel                                      >> impact_batch_commands.cmd
@echo setPreference -pref StartupClock:Auto_Correction             >> impact_batch_commands.cmd
@echo addPromDevice -p 1 -size 16384                               >> impact_batch_commands.cmd
@echo addDesign -version 0 -startaddress 000000                    >> impact_batch_commands.cmd
@echo addDeviceChain -index 0                                      >> impact_batch_commands.cmd
@echo addDevice -p 1 -file %bitfile%                               >> impact_batch_commands.cmd
@echo generate -format mcs -fillvalue FF -output %outfile%         >> impact_batch_commands.cmd
@echo quit                                                         >> impact_batch_commands.cmd
impact -batch impact_batch_commands.cmd

REM # swap data byte pairs (e.g., 0x5599AA66 becomes 0x995566AA)
REM # This is required since the flash is written in x16 mode
REM #  but readback for BPI configuration in x8 mode
xmcsutil -accept_notice -21 -i %outfile%.mcs -o %outfile%_1.mcs

REM # convert MCS to HEX (MCS addresses removed)
REM # This is required since MCS can't be converted directly
REM #  to binary
xmcsutil -accept_notice -1 -i %outfile%_1.mcs -o %outfile%_2.hex

REM # convert HEX to binary
REM # Binary is required since the bits are being stored directly
REM #  in the flash
xmcsutil -accept_notice -18 -i %outfile%_2.hex -o %outfile%.bin

REM # Clean-up
del *.prm
del *.sig
del _impactbatch.log
del impact_batch_commands.cmd
del _impact.cmd
del *cclktemp.bit
del *.mcs
del *.hex

pause
